package rps;

import static rps.Move.PAPER;
import static rps.Move.ROCK;
import static rps.Move.SCISSORS;
import osl.manager.Actor;
import osl.manager.ActorName;
import osl.manager.RemoteCodeException;
import osl.manager.annotations.message;

public class Coordinator extends Actor {

  ActorName player1;
  ActorName player2;
  
  Move firstMove;
  String firstPlayer;
  
  @message public void boot() throws RemoteCodeException {
    player1 = create(Player.class, "Player 1");
    player2 = create(Player.class, "Player 2");
    send(self(), "start");
  }

  @message public void start() {
    send(player1, "play", self());
    send(player2, "play", self());
  }
  
  @message public void playerThrows(String player, Move move) {
    if(firstMove == null) {
      firstMove = move;
      firstPlayer = player;
    } else {
      announce(firstPlayer, firstMove, player, move);
      send(self(), "start");
    }
  }
  
  private void announce(String p1, Move m1, String p2, Move m2) {
    String winner = "tie";
    if(firstWins(m1, m2) && ! firstWins(m2, m1)) {
      winner = p1;
    } else if(firstWins(m2, m1) && ! firstWins(m1, m2)) {
      winner = p2;
    } // else tie
    
    if(p1.compareTo(p2) < 0) {
      System.out.println(toString(p1, m1) + ", " + toString(p2, m2) + ", winner = " + winner);      
    } else {
      System.out.println(toString(p2, m2) + ", " + toString(p1, m1) + ", winner = " + winner);            
    }
  }
  
  private String toString(String player, Move move) {
    return player + " (" + move + ")";
  }
  
  private boolean firstWins(Move m1, Move m2) {
    return 
      (m1 == ROCK && m2 == SCISSORS) || 
      (m1 == PAPER && m2 == ROCK) ||
      (m1 == SCISSORS && m2 == PAPER);
  }
}
