package rps;

import java.util.Random;

import osl.manager.Actor;
import osl.manager.ActorName;
import osl.manager.annotations.message;

public class Player extends Actor {
  private static final Random RANDOM = new Random();
  private String name;
  
  public Player(String name) {
    this.name = name;
  }
  
  @message public void play(ActorName coordinator) {
    send(coordinator, "playerThrows", name, randomMove());

  }
  
  private Move randomMove() {
    return Move.values()[RANDOM.nextInt(Move.values().length)];
  }
}
