package rps;

import java.util.Random;

import org.actorsguildframework.Actor;
import org.actorsguildframework.AsyncResult;
import org.actorsguildframework.annotations.Message;
import org.actorsguildframework.annotations.Prop;

import rps.msg.Move;
import rps.msg.ThrowMessage;

public abstract class Player extends Actor {
  private static final Random RANDOM = new Random();
  
  @Prop
  public abstract String getName();
  public abstract void setName(String name);
  
  @Message
  public AsyncResult<ThrowMessage> play() {
    return result(new ThrowMessage(getName(), randomMove()));
  }
  
  private Move randomMove() {
    return Move.values()[RANDOM.nextInt(Move.values().length)];
  }
}
