package rps;

import org.jetlang.channels.Channel;
import org.jetlang.core.Callback;
import org.jetlang.fibers.Fiber;

public class Actor<T> {
  private final Channel<T> inbox;
  private final Fiber fiber;
  private final Callback<T> callbackFunction;
  
  public Actor(Fiber fiber, Channel<T> inbox, Callback<T> callbackFunction) {
    this.fiber = fiber;
    this.inbox = inbox;
    this.callbackFunction = callbackFunction;
  }
  
  public Channel<T> inbox() {
    return this.inbox;
  }
  
  public Fiber fiber() {
    return this.fiber;
  }
  
  public Callback<T> callbackFunction() { 
    return this.callbackFunction;
  }
  
  public void send(T message) {
    this.inbox.publish(message);
  }
}
