package rps;

import java.util.Random;

import org.jetlang.core.Callback;

import rps.msg.Move;
import rps.msg.PlayMessage;
import rps.msg.ThrowMessage;

public class Player implements Callback<PlayMessage> {
  private static final Random RANDOM = new Random();
  private final String name;
  
  public Player(String name) {
    this.name = name;
  }
  
  private Move randomMove() {
    return Move.values()[RANDOM.nextInt(Move.values().length)];
  }
  
  public void onMessage(PlayMessage message) {
    message.getResponseActor().send(new ThrowMessage(name, randomMove()));
  }
}
