package rps;

import rps.msg.Message;
import rps.msg.PlayMessage;
import rps.msg.StartMessage;

public class RockPaperScissors {
  public static void main(String[] args) {
    ActorFactory actors = new ActorFactory();
    
    // Create actors
    Actor<PlayMessage> player1 = actors.createActor(new Player("Player1"));
    Actor<PlayMessage> player2 = actors.createActor(new Player("Player2"));
    
    Coordinator coordinatorFunction = new Coordinator(player1, player2);
    Actor<Message> coordinator = actors.createActor(coordinatorFunction);
    coordinatorFunction.setCoordinator(coordinator);
    
    // Start work
    coordinator.send(StartMessage.INSTANCE);
    
    try {
      Thread.sleep(100000);
    } catch(InterruptedException e) {
      
    }
  }
  
}
