package rps;

import java.util.Random;

import kilim.Mailbox;
import kilim.Pausable;
import kilim.Task;
import rps.msg.Move;
import rps.msg.PlayMessage;
import rps.msg.ThrowMessage;

public class Player extends Task {
  private static final Random RANDOM = new Random();

  private final String name;
  private final Mailbox<PlayMessage> inbox;
  
  public Player(String name, Mailbox<PlayMessage> inbox) {
    this.name = name;
    this.inbox = inbox;
  }
  
  public void execute() throws Pausable {
    while(true) {
      PlayMessage message = inbox.get();
      message.getResponseMailbox().putnb(new ThrowMessage(name, randomMove()));
    }
  }
  
  private Move randomMove() {
    return Move.values()[RANDOM.nextInt(Move.values().length)];
  }
}
